#pragma once

#include <sapi.h>
#include <sphelper.h>
#pragma comment(lib,"sapi.lib")
//#include <sapi.h>
//#pragma comment(lib,"sapi")
/*
#include <objbase.h>
#pragma comment(lib,"ole32")
*/
#include <windows.h>

class CVoice
{
protected:
    ISpVoice* pVoice;
    BOOL GetVoiceToken(WCHAR* TTSName, OUT ISpObjectToken** ppToken);
public:
    CVoice(void);
    ~CVoice(void);

    typedef BOOL (*tagCallBackEnumVoices)(WCHAR* TTSName,PVOID UserParam);

    BOOL Load();
    BOOL SetVoice(WCHAR* TTSName);
    BOOL UnLoad();
    BOOL IsLoaded();
    BOOL Read(WCHAR* TextToRead,BOOL bPurgeBeforeRead = FALSE,BOOL bSynchronous=FALSE);
    BOOL StopReading();
    BOOL IsReading();
    BOOL WaitEndOfReading(ULONG MsTimeOut = INFINITE);
    BOOL GetSpeedAndVolume(OUT LONG* pSpeed,OUT USHORT* pVolume);
    BOOL SetSpeedAndVolume(LONG Speed,USHORT Volume);
    BOOL EnumVoices(tagCallBackEnumVoices CallBack,PVOID UserParam);
    // GetSpeakCompleteEvent : Warning Msdn "The caller should not call CloseHandle(), nor should the caller ever use the handle after releasing the COM reference to this voice"
    HANDLE GetSpeakCompleteEvent();
    BOOL DisplayUI(HWND hwndParent);
};
