#pragma once

#include "resource.h"
#include "Options.h"
#include "../Tools/gui/Dialog/DialogHelper.h"

class CHotKeyUI
{
private:
    HINSTANCE hInstance;
    HWND hWndDialog;
    HWND hParentHandle;
    COptions* pOptions;

    void OnOk();
    void OnCancel();
    void OnInit();
    void OnClose();

    static CHotKeyUI* GetAssociatedObject(HWND hWndDialog);
    static LRESULT CALLBACK WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
public:
    CHotKeyUI(void);
    ~CHotKeyUI(void);

    static INT_PTR Show(HINSTANCE hInstance,HWND hWndDialog,COptions* pOptions);
};
