#pragma once

#include "resource.h"
#include "../Tools/GUI/Dialog/DialogBase.h"
#include "../Tools/GUI/SelectWindow/SelectWindow.h"

class CSelectWindowUI:CDialogBase
{
private:
    HWND hWndSelectedWindow;
    CSelectWindow SelectWindow;

    virtual void OnInit();
    virtual void OnCommand(WPARAM wParam,LPARAM lParam);
    virtual void OnMouseDown(WPARAM wParam,LPARAM lParam);
    virtual void OnMouseUp(WPARAM wParam,LPARAM lParam);
    virtual void OnMouseMove(WPARAM wParam,LPARAM lParam);
    void OnOk();
    void OnCancel();

    CSelectWindowUI(void);
    virtual ~CSelectWindowUI(void);
public:
    static INT_PTR Show(HINSTANCE hInstance,HWND hWndDialog,OUT HWND* phWindow);
};

