#pragma once

#include "../Tools/gui/Dialog/DialogBase.h"
#include "Voice.h"
#include "Options.h"
class CVoiceOptions :public CDialogBase
{
private:
    CVoiceOptions(CVoice* pVoice,COptions* pOptions);
    virtual ~CVoiceOptions(void);

    CVoice* pVoice;
    COptions* pOptions;
    USHORT OriginalVolume;
    LONG OriginalRate;

    USHORT CurrentVolume;
    LONG CurrentRate;
    HWND SliderSpeed;
    HWND SliderVolume;
    BOOL bApplyChanges;

    virtual void OnInit();
    virtual BOOL OnClose();
    virtual void OnCommand(WPARAM wParam,LPARAM lParam);
    virtual LRESULT OnMessage(UINT uMsg,WPARAM wParam,LPARAM lParam);
    void OnOk();
    void OnCancel();
    void OnTest();
public:
    static INT_PTR Show(HINSTANCE hInstance,HWND hWndDialog,CVoice* pVoice,COptions* pOptions);
};

