#pragma once

#include <Windows.h>



class CClipboardViewer
{
public:
    typedef void (*pfOnClipBoardChangeCallBack)(PVOID UserParam);

protected:
    HWND hwndNextViewer;
    HWND hWndDlg;
    pfOnClipBoardChangeCallBack OnClipBoardChangeCallBack;
    PVOID OnClipBoardChangeCallBackUserParam;
    BOOL CallOnClipBoardChangeCallBackForCurrentClipBoardContent;
    BOOL FirstMessageAfterRegistration;
public:

    CClipboardViewer(void);
    ~CClipboardViewer(void);
    BOOL Register(HWND hWndDlg, BOOL CallOnClipBoardChangeCallBackForCurrentClipBoardContent= FALSE);
    BOOL Unregister();
    LRESULT OnMessage(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
    BOOL SetClipBoardChangeCallBack(pfOnClipBoardChangeCallBack pFunction,PVOID UserParam);
};

